/* ../src/locpoly.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;

/* ccccccccc FORTRAN subroutine locpol.f cccccccccc */
/* For computing an binned approximation to a */
/* local bandwidth local polynomial kernel regression estimator */
/* of an arbitrary derivative of a regression function. */
/* LINPACK is used for matrix inversion. */
/* Last changed: 10/02/95 */
/* Subroutine */ int locpol_(xcounts, ycounts, idrv, delta, hdisc, lvec, 
	indic, midpts, m, iq, fkap, ipp, ippp, ss, tt, smat, tvec, ipvt, 
	curvest)
doublereal *xcounts, *ycounts;
integer *idrv;
doublereal *delta, *hdisc;
integer *lvec, *indic, *midpts, *m, *iq;
doublereal *fkap;
integer *ipp, *ippp;
doublereal *ss, *tt, *smat, *tvec;
integer *ipvt;
doublereal *curvest;
{
    /* System generated locals */
    integer ss_dim1, ss_offset, tt_dim1, tt_offset, smat_dim1, smat_offset, 
	    i__1, i__2, i__3, i__4, i__5, i__6, i__7;
    doublereal d__1;

    /* Builtin functions */
    double exp();

    /* Local variables */
    static integer info;
    extern /* Subroutine */ int dgefa_();
    static integer i, j, k;
    extern /* Subroutine */ int dgesl_();
    static integer indss, ii;
    static doublereal fac;
    static integer mid;

/* Obtain kernel weights */
    /* Parameter adjustments */
    --xcounts;
    --ycounts;
    --hdisc;
    --lvec;
    --indic;
    --midpts;
    --fkap;
    --tvec;
    smat_dim1 = *ipp;
    smat_offset = smat_dim1 + 1;
    smat -= smat_offset;
    tt_dim1 = *m;
    tt_offset = tt_dim1 + 1;
    tt -= tt_offset;
    ss_dim1 = *m;
    ss_offset = ss_dim1 + 1;
    ss -= ss_offset;
    --ipvt;
    --curvest;

    /* Function Body */
    mid = lvec[1] + 1;
    i__1 = *iq - 1;
    for (i = 1; i <= i__1; ++i) {
	midpts[i] = mid;
	fkap[mid] = (float)1.;
	i__2 = lvec[i];
	for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
	    d__1 = *delta * j / hdisc[i];
	    fkap[mid + j] = exp(-(d__1 * d__1) / 2);
	    fkap[mid - j] = fkap[mid + j];
/* L20: */
	}
	mid = mid + lvec[i] + lvec[i + 1] + 1;
/* L10: */
    }
    midpts[*iq] = mid;
    fkap[mid] = (float)1.;
    i__1 = lvec[*iq];
    for (j = 1; j <= i__1; ++j) {
/* Computing 2nd power */
	d__1 = *delta * j / hdisc[*iq];
	fkap[mid + j] = exp(-(d__1 * d__1) / 2);
	fkap[mid - j] = fkap[mid + j];
/* L30: */
    }
/* Combine kernel weights and grid counts */
    i__1 = *m;
    for (k = 1; k <= i__1; ++k) {
	if (xcounts[k] != 0.) {
	    i__2 = *iq;
	    for (i = 1; i <= i__2; ++i) {
/* Computing MAX */
		i__3 = 1, i__4 = k - lvec[i];
/* Computing MIN */
		i__6 = *m, i__7 = k + lvec[i];
		i__5 = min(i__6,i__7);
		for (j = max(i__3,i__4); j <= i__5; ++j) {
		    if (indic[j] == i) {
			fac = (float)1.;
			ss[j + ss_dim1] += xcounts[k] * fkap[k - j + midpts[i]
				];
			tt[j + tt_dim1] += ycounts[k] * fkap[k - j + midpts[i]
				];
			i__3 = *ippp;
			for (ii = 2; ii <= i__3; ++ii) {
			    fac = fac * *delta * (k - j);
			    ss[j + ii * ss_dim1] += xcounts[k] * fkap[k - j + 
				    midpts[i]] * fac;
			    if (ii <= *ipp) {
				tt[j + ii * tt_dim1] += ycounts[k] * fkap[k - 
					j + midpts[i]] * fac;
			    }
/* L70: */
			}
		    }
/* L60: */
		}
/* L50: */
	    }
	}
/* L40: */
    }
    i__1 = *m;
    for (k = 1; k <= i__1; ++k) {
	i__2 = *ipp;
	for (i = 1; i <= i__2; ++i) {
	    i__5 = *ipp;
	    for (j = 1; j <= i__5; ++j) {
		indss = i + j - 1;
		smat[i + j * smat_dim1] = ss[k + indss * ss_dim1];
/* L100: */
	    }
	    tvec[i] = tt[k + i * tt_dim1];
/* L90: */
	}
	dgefa_(&smat[smat_offset], ipp, ipp, &ipvt[1], &info);
	dgesl_(&smat[smat_offset], ipp, ipp, &ipvt[1], &tvec[1], &c__0);
	curvest[k] = tvec[*idrv + 1];
/* L80: */
    }
    return 0;
} /* locpol_ */

